<template>
  <v-card
      min-width="300"
      width="500"
      elevation="0"
  >
    <v-card-title>
      Please login
    </v-card-title>
    <v-card-text>
      <v-form
          @submit.prevent="login"
      >
        <v-text-field
            label="Phone number"
            v-model="form.username"
            outlined
            v-validate="'required|numeric'"
            data-vv-name="phone"
            :error-messages="errors.collect('phone')"
        />
        <v-text-field
            label="Password"
            v-model="form.email"
            outlined
            type="password"
            v-validate="'required'"
            data-vv-name="password"
            :error-messages="errors.collect('password')"
        />
        <div class="d-flex flex-column align-center">
          <v-btn
              class="mt-2"
              type="submit"
              color="primary"
          >Log in
          </v-btn>
          <br>
          <small>dont have an account? go to the sign-up page</small>
          <v-btn
              :class="{'full-width-btn': $vuetify.breakpoint.xsOnly}"
              class="mt-2"
              color="primary"
              @click="redirectToSignup">Go to SignUp Page
          </v-btn>
        </div>
      </v-form>
    </v-card-text>
  </v-card>
</template>

<script>
import {mapActions} from "vuex"

export default {
  name: "Login",
  data: () => ({
    form: {
      username: '',
      email: '',
    },
    loading: false,
  }),
  methods: {
    ...mapActions(['setIsAuthenticated']),
    redirectToSignup() {
      this.$router.push({name: 'signup'})
    },
    login: async function () {
      try {
        this.loading = true;
        const isValid = await this.$validator.validate();
        if (isValid) {
          const payload = new FormData()
          payload.append('email', this.form.email)
          payload.append('username', this.form.username)

          const response = await this.$axios.post('/api/login', payload)

          if (response && response.status === 200) {
            document.cookie = `PHPSESSID=${response.data}`
            this.setIsAuthenticated(true)
            this.$router.push({name: 'dashboard'})
          }
        }
      } catch (err) {
        console.log(err);
      } finally {
        this.loading = false;
      }
    },
  }
}
</script>

<style scoped>

</style>
